// $Date:: 2011-12-10 22:23:09 +0900#$
// $Rev: 5 $

// avisynth ưġ

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#ifdef __MINGW_H
#include <malloc.h>
#else
#include <alloca.h>
#endif /* __MINGW_H */
#include <sys/stat.h>

#define C_TEMPLATE_V "template.v.avs"
#define C_TEMPLATE_A "template.a.avs"
#define C_TEMPLATE_B "template.bat"

#define C_LIST "list"

#define C_FUNCNAME ""

typedef struct _S_LINE
{
    char * pa_orgfile ;
    char * pa_newfile ;
    char * pa_timetrim ;
} S_LINE ;

static int template_aply ( const char * pa_templatefile , const char * pa_fileformat , const S_LINE * ps_lines , int n_lines ) ;
static int template_outfile ( const char * pa_template , const char * pa_outfile , const S_LINE * ps_lines) ;
static int create_batch ( const char * pa_templatefile , const char * pa_outfile , const char * pa_vfile , const char * pa_afile , const S_LINE * ps_lines , int n_lines ) ;


int main ( int argc , char * argv [] )
{
    S_LINE * ps_lines;
    char ppa_buff [ 3 ][1024 ] ;
    int n_lines = 0 ;
    // if ( argc < 2 )
    // {
    //     perror ( "­ޤ" ) ;
    //     exit -1 ;
    // }

    FILE * fp = fopen ( C_LIST , "r" ) ;
    if ( ! fp ) exit ( -1 ) ;

    while ( fgets ( ppa_buff [ 0 ] , sizeof ( ppa_buff [ 0 ] ) , fp ) ) n_lines ++ ;
    ps_lines= (S_LINE*) alloca ( sizeof (S_LINE) * n_lines )  ;

    rewind ( fp ) ;

    for ( int i = 0 ; i < n_lines ; i ++ )
    {
        int n_ret ;

        n_ret = fscanf ( fp , "%[^\t\n]%*[\t]%[^\t\n]%*[\t]%[^\t\n]" ,
                 ppa_buff [ 0 ] ,
                 ppa_buff [ 1 ] ,
                 ppa_buff [ 2 ] ) ;
        if ( n_ret != 3 ) exit ( -1 ) ;
        fscanf ( fp , "%*[^\n]" ) ;
        fscanf ( fp , "%*[\n]" ) ;

        ps_lines[ i ].pa_orgfile  = (char*) alloca ( strlen ( ppa_buff [ 0 ] ) + 1 ) ;
        ps_lines[ i ].pa_timetrim = (char*) alloca ( strlen ( ppa_buff [ 1 ] ) + 1 ) ;
        ps_lines[ i ].pa_newfile  = (char*) alloca ( strlen ( ppa_buff [ 2 ] ) + 1 ) ;

        strcpy ( ps_lines[ i ].pa_orgfile  , ppa_buff [ 0 ] ) ;
        strcpy ( ps_lines[ i ].pa_timetrim , ppa_buff [ 1 ] ) ;
        strcpy ( ps_lines[ i ].pa_newfile  , ppa_buff [ 2 ] ) ;
    }

    fclose ( fp ) ;

    template_aply ( C_TEMPLATE_V , "%06d.v.avs" , ps_lines, n_lines ) ;
    template_aply ( C_TEMPLATE_A , "%06d.a.avs" , ps_lines, n_lines ) ;
    create_batch  ( C_TEMPLATE_B , "enc.bat" , "%06d.v.avs" , "%06d.a.avs" , ps_lines , n_lines ) ;
}

static int template_aply ( const char * pa_templatefile , const char * pa_fileformat , const S_LINE * ps_lines , int n_lines )
{
    char * pa_template ;
    struct stat s_stat ;
    FILE * fp ;

    stat ( pa_templatefile , & s_stat ) ;
    pa_template = (char*) alloca ( s_stat.st_size + 1 ) ;

    fp = fopen ( pa_templatefile , "rb" ) ;
    if ( ! fp ) exit ( -1 ) ;

    fread ( pa_template , 1 , s_stat.st_size , fp ) ;
    pa_template [ s_stat.st_size ] = '\0' ;

    fclose ( fp ) ;

    for ( int i = 0 ; i < n_lines ; i ++ )
    {
        char pa_outfile [ 1024 ] ;
        sprintf ( pa_outfile , pa_fileformat , i ) ;
        template_outfile ( pa_template , pa_outfile , ps_lines+ i ) ;
    }

    return 0 ;
}

static int template_outfile ( const char * pa_template , const char * pa_outfile , const S_LINE * ps_line )
{
    const char * pppa_reptable [][ 2 ] = {
        { "__INFILE__"   , ps_line->pa_orgfile  } ,
        { "__OUTFILE__"  , ps_line->pa_newfile  } ,
        { "__TIMETRIM__" , ps_line->pa_timetrim } ,
        { NULL , NULL } } ;
    const char * pa_end = pa_template + strlen ( pa_template ) ;
    const char * pa_cur = pa_template ;
    FILE * fp ;

    fp = fopen ( pa_outfile , "wb" ) ;
    if ( ! fp ) exit ( -1 ) ;

    while ( pa_cur [ 0 ] )
    {
        const char * pa_next = pa_end ;
        const char ** ppa_repstrs = NULL ; 

        for ( int j = 0 ; pppa_reptable [ j ][ 0 ] ; j ++ )
        {
            char * pa_work = strstr ( pa_cur , pppa_reptable [ j ][ 0 ] ) ;
            if ( pa_work && pa_work < pa_next )
            {
                pa_next = pa_work ;
                ppa_repstrs = pppa_reptable [ j ] ;
            }
        }

        fwrite ( pa_cur , 1 , pa_next - pa_cur , fp ) ;
        if ( ppa_repstrs )
        {
            fprintf ( fp , "%s" , ppa_repstrs [ 1 ] ) ;
            pa_cur = pa_next + strlen ( ppa_repstrs [ 0 ] ) ;
        }
        else
        {
            pa_cur = pa_next ;
        }
    }

    fclose ( fp ) ;

    return 0 ;
}

static int create_batch ( const char * pa_templatefile , const char * pa_outfile , const char * pa_vfile , const char * pa_afile , const S_LINE * ps_lines , int n_lines )
{
    const char * pa_next ;
    const char * pa_cur  ;
    char pa_commandformat [ 1024 ] ;
    FILE * fp ;
    struct stat s_stat ;
    char * pa_template ;

    sprintf ( pa_commandformat , "call :ENCFUNC %s %s \"%%s\"\r\n" , pa_vfile ,  pa_afile ) ;

    stat ( pa_templatefile , & s_stat ) ;
    pa_template = (char*) alloca ( s_stat.st_size + 1 ) ;

    fp = fopen ( pa_templatefile , "rb" ) ;
    if ( ! fp ) exit ( -1 ) ;

    fread ( pa_template , 1 , s_stat.st_size , fp ) ;
    pa_template [ s_stat.st_size ] = '\0' ;

    fclose ( fp ) ;

    fp = fopen ( pa_outfile , "wb" ) ;
    if ( ! fp ) exit ( -1 ) ;

    pa_cur = pa_template ;
    while ( ( pa_next = strstr ( pa_cur , "__ENCFUNC__" ) ) )
    {
        fwrite ( pa_cur , 1 , pa_next - pa_cur , fp ) ;

        for ( int i = 0 ; i < n_lines ; i ++ )
        {
            fprintf ( fp , pa_commandformat , i , i , ps_lines [ i ].pa_newfile ) ;
        }

        pa_cur = pa_next + strlen ( "__ENCFUNC__" ) ;
    }

    fprintf ( fp , "%s" , pa_cur ) ;

    fclose ( fp ) ;

    return 0 ;
}
